/* EventRow.c generated by valac 0.48.2, the Vala compiler
 * generated from EventRow.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <libical-glib/libical-glib.h>
#include <libedataserver/libedataserver.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#define DATE_TIME_TYPE_EVENT_ROW (date_time_event_row_get_type ())
#define DATE_TIME_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRow))
#define DATE_TIME_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRowClass))
#define DATE_TIME_IS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DATE_TIME_TYPE_EVENT_ROW))
#define DATE_TIME_IS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DATE_TIME_TYPE_EVENT_ROW))
#define DATE_TIME_EVENT_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRowClass))

typedef struct _DateTimeEventRow DateTimeEventRow;
typedef struct _DateTimeEventRowClass DateTimeEventRowClass;
typedef struct _DateTimeEventRowPrivate DateTimeEventRowPrivate;
enum  {
	DATE_TIME_EVENT_ROW_0_PROPERTY,
	DATE_TIME_EVENT_ROW_DATE_PROPERTY,
	DATE_TIME_EVENT_ROW_COMPONENT_PROPERTY,
	DATE_TIME_EVENT_ROW_CAL_PROPERTY,
	DATE_TIME_EVENT_ROW_START_TIME_PROPERTY,
	DATE_TIME_EVENT_ROW_END_TIME_PROPERTY,
	DATE_TIME_EVENT_ROW_IS_ALLDAY_PROPERTY,
	DATE_TIME_EVENT_ROW_NUM_PROPERTIES
};
static GParamSpec* date_time_event_row_properties[DATE_TIME_EVENT_ROW_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define DATE_TIME_SERVICES_TYPE_TIME_MANAGER (date_time_services_time_manager_get_type ())
#define DATE_TIME_SERVICES_TIME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DATE_TIME_SERVICES_TYPE_TIME_MANAGER, DateTimeServicesTimeManager))
#define DATE_TIME_SERVICES_TIME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DATE_TIME_SERVICES_TYPE_TIME_MANAGER, DateTimeServicesTimeManagerClass))
#define DATE_TIME_SERVICES_IS_TIME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DATE_TIME_SERVICES_TYPE_TIME_MANAGER))
#define DATE_TIME_SERVICES_IS_TIME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DATE_TIME_SERVICES_TYPE_TIME_MANAGER))
#define DATE_TIME_SERVICES_TIME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DATE_TIME_SERVICES_TYPE_TIME_MANAGER, DateTimeServicesTimeManagerClass))

typedef struct _DateTimeServicesTimeManager DateTimeServicesTimeManager;
typedef struct _DateTimeServicesTimeManagerClass DateTimeServicesTimeManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DateTimeEventRow {
	GtkListBoxRow parent_instance;
	DateTimeEventRowPrivate * priv;
};

struct _DateTimeEventRowClass {
	GtkListBoxRowClass parent_class;
};

struct _DateTimeEventRowPrivate {
	GDateTime* _date;
	ICalComponent* _component;
	ESourceCalendar* _cal;
	GDateTime* _start_time;
	GDateTime* _end_time;
	gboolean _is_allday;
	GtkGrid* grid;
	GtkImage* event_image;
	GtkLabel* time_label;
};

static gint DateTimeEventRow_private_offset;
static gpointer date_time_event_row_parent_class = NULL;
static DateTimeServicesTimeManager* date_time_event_row_time_manager;
static DateTimeServicesTimeManager* date_time_event_row_time_manager = NULL;
static GtkCssProvider* date_time_event_row_css_provider;
static GtkCssProvider* date_time_event_row_css_provider = NULL;

GType date_time_event_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DateTimeEventRow, g_object_unref)
GType date_time_services_time_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DateTimeServicesTimeManager, g_object_unref)
DateTimeEventRow* date_time_event_row_new (GDateTime* date,
                                           ICalComponent* component,
                                           ESource* source);
DateTimeEventRow* date_time_event_row_construct (GType object_type,
                                                 GDateTime* date,
                                                 ICalComponent* component,
                                                 ESource* source);
static void date_time_event_row_update_timelabel (DateTimeEventRow* self);
gboolean date_time_services_time_manager_get_is_12h (DateTimeServicesTimeManager* self);
GDateTime* date_time_event_row_get_start_time (DateTimeEventRow* self);
GDateTime* date_time_event_row_get_end_time (DateTimeEventRow* self);
static void date_time_event_row_set_color (DateTimeEventRow* self);
void util_set_event_calendar_color (ESourceCalendar* cal,
                                    GtkWidget* widget);
ESourceCalendar* date_time_event_row_get_cal (DateTimeEventRow* self);
GDateTime* date_time_event_row_get_date (DateTimeEventRow* self);
static void date_time_event_row_set_date (DateTimeEventRow* self,
                                   GDateTime* value);
ICalComponent* date_time_event_row_get_component (DateTimeEventRow* self);
static void date_time_event_row_set_component (DateTimeEventRow* self,
                                        ICalComponent* value);
static void date_time_event_row_set_cal (DateTimeEventRow* self,
                                  ESourceCalendar* value);
static void date_time_event_row_set_start_time (DateTimeEventRow* self,
                                         GDateTime* value);
static void date_time_event_row_set_end_time (DateTimeEventRow* self,
                                       GDateTime* value);
gboolean date_time_event_row_get_is_allday (DateTimeEventRow* self);
static void date_time_event_row_set_is_allday (DateTimeEventRow* self,
                                        gboolean value);
static GObject * date_time_event_row_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
GDateTime* util_ical_to_date_time (ICalTime* date);
gboolean util_is_the_all_day (GDateTime* dtstart,
                              GDateTime* dtend);
static void _date_time_event_row_set_color_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _date_time_event_row_update_timelabel_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
DateTimeServicesTimeManager* date_time_services_time_manager_get_default (void);
static void date_time_event_row_finalize (GObject * obj);
static GType date_time_event_row_get_type_once (void);
static void _vala_date_time_event_row_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_date_time_event_row_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
date_time_event_row_get_instance_private (DateTimeEventRow* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeEventRow_private_offset);
}

DateTimeEventRow*
date_time_event_row_construct (GType object_type,
                               GDateTime* date,
                               ICalComponent* component,
                               ESource* source)
{
	DateTimeEventRow * self = NULL;
	ESourceExtension* _tmp0_;
	g_return_val_if_fail (date != NULL, NULL);
	g_return_val_if_fail (component != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
	self = (DateTimeEventRow*) g_object_new (object_type, "component", component, "date", date, "cal", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar), NULL);
	return self;
}

DateTimeEventRow*
date_time_event_row_new (GDateTime* date,
                         ICalComponent* component,
                         ESource* source)
{
	return date_time_event_row_construct (DATE_TIME_TYPE_EVENT_ROW, date, component, source);
}

static void
date_time_event_row_update_timelabel (DateTimeEventRow* self)
{
	gchar* time_format = NULL;
	DateTimeServicesTimeManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GDateTime* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GDateTime* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = date_time_event_row_time_manager;
	_tmp1_ = date_time_services_time_manager_get_is_12h (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = granite_date_time_get_default_time_format (_tmp2_, FALSE);
	time_format = _tmp3_;
	_tmp4_ = self->priv->time_label;
	_tmp5_ = self->priv->_start_time;
	_tmp6_ = g_date_time_format (_tmp5_, time_format);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->_end_time;
	_tmp9_ = g_date_time_format (_tmp8_, time_format);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strdup_printf ("<small>%s – %s</small>", _tmp7_, _tmp10_);
	_tmp12_ = _tmp11_;
	gtk_label_set_label (_tmp4_, _tmp12_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp7_);
	_g_free0 (time_format);
}

static void
date_time_event_row_set_color (DateTimeEventRow* self)
{
	ESourceCalendar* _tmp0_;
	GtkGrid* _tmp1_;
	ESourceCalendar* _tmp2_;
	GtkImage* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_cal;
	_tmp1_ = self->priv->grid;
	util_set_event_calendar_color (_tmp0_, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->_cal;
	_tmp3_ = self->priv->event_image;
	util_set_event_calendar_color (_tmp2_, (GtkWidget*) _tmp3_);
}

GDateTime*
date_time_event_row_get_date (DateTimeEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
date_time_event_row_set_date (DateTimeEventRow* self,
                              GDateTime* value)
{
	g_return_if_fail (self != NULL);
	if (date_time_event_row_get_date (self) != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_date);
		self->priv->_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_event_row_properties[DATE_TIME_EVENT_ROW_DATE_PROPERTY]);
	}
}

ICalComponent*
date_time_event_row_get_component (DateTimeEventRow* self)
{
	ICalComponent* result;
	ICalComponent* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_component;
	result = _tmp0_;
	return result;
}

static void
date_time_event_row_set_component (DateTimeEventRow* self,
                                   ICalComponent* value)
{
	g_return_if_fail (self != NULL);
	if (date_time_event_row_get_component (self) != value) {
		self->priv->_component = value;
		g_object_notify_by_pspec ((GObject *) self, date_time_event_row_properties[DATE_TIME_EVENT_ROW_COMPONENT_PROPERTY]);
	}
}

ESourceCalendar*
date_time_event_row_get_cal (DateTimeEventRow* self)
{
	ESourceCalendar* result;
	ESourceCalendar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cal;
	result = _tmp0_;
	return result;
}

static void
date_time_event_row_set_cal (DateTimeEventRow* self,
                             ESourceCalendar* value)
{
	g_return_if_fail (self != NULL);
	if (date_time_event_row_get_cal (self) != value) {
		self->priv->_cal = value;
		g_object_notify_by_pspec ((GObject *) self, date_time_event_row_properties[DATE_TIME_EVENT_ROW_CAL_PROPERTY]);
	}
}

GDateTime*
date_time_event_row_get_start_time (DateTimeEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_start_time;
	result = _tmp0_;
	return result;
}

static void
date_time_event_row_set_start_time (DateTimeEventRow* self,
                                    GDateTime* value)
{
	g_return_if_fail (self != NULL);
	if (date_time_event_row_get_start_time (self) != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_start_time);
		self->priv->_start_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_event_row_properties[DATE_TIME_EVENT_ROW_START_TIME_PROPERTY]);
	}
}

GDateTime*
date_time_event_row_get_end_time (DateTimeEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_end_time;
	result = _tmp0_;
	return result;
}

static void
date_time_event_row_set_end_time (DateTimeEventRow* self,
                                  GDateTime* value)
{
	g_return_if_fail (self != NULL);
	if (date_time_event_row_get_end_time (self) != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_end_time);
		self->priv->_end_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_event_row_properties[DATE_TIME_EVENT_ROW_END_TIME_PROPERTY]);
	}
}

gboolean
date_time_event_row_get_is_allday (DateTimeEventRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_allday;
	return result;
}

static void
date_time_event_row_set_is_allday (DateTimeEventRow* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (date_time_event_row_get_is_allday (self) != value) {
		self->priv->_is_allday = value;
		g_object_notify_by_pspec ((GObject *) self, date_time_event_row_properties[DATE_TIME_EVENT_ROW_IS_ALLDAY_PROPERTY]);
	}
}

static void
_date_time_event_row_set_color_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	date_time_event_row_set_color ((DateTimeEventRow*) self);
}

static void
_date_time_event_row_update_timelabel_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	date_time_event_row_update_timelabel ((DateTimeEventRow*) self);
}

static GObject *
date_time_event_row_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DateTimeEventRow * self;
	ICalComponent* _tmp0_;
	ICalTime* _tmp1_;
	ICalTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	ICalComponent* _tmp5_;
	ICalTime* _tmp6_;
	ICalTime* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GDateTime* _tmp11_;
	const gchar* icon_name = NULL;
	GDateTime* _tmp14_;
	const gchar* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkStyleContext* event_image_context = NULL;
	GtkImage* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkCssProvider* _tmp21_;
	GtkLabel* name_label = NULL;
	ICalComponent* _tmp22_;
	const gchar* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkStyleContext* name_label_context = NULL;
	GtkLabel* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkStyleContext* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkCssProvider* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkStyleContext* _tmp41_;
	GtkGrid* _tmp42_;
	GtkGrid* _tmp43_;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* _tmp46_;
	GtkGrid* _tmp47_;
	GtkImage* _tmp48_;
	GtkGrid* _tmp49_;
	GtkLabel* _tmp50_;
	gboolean _tmp51_;
	GtkStyleContext* grid_context = NULL;
	GtkGrid* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkStyleContext* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkCssProvider* _tmp58_;
	GtkGrid* _tmp59_;
	ESourceCalendar* _tmp60_;
	DateTimeServicesTimeManager* _tmp61_;
	parent_class = G_OBJECT_CLASS (date_time_event_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRow);
	_tmp0_ = self->priv->_component;
	_tmp1_ = i_cal_component_get_dtstart (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = util_ical_to_date_time (_tmp2_);
	_tmp4_ = _tmp3_;
	date_time_event_row_set_start_time (self, _tmp4_);
	_g_date_time_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	_tmp5_ = self->priv->_component;
	_tmp6_ = i_cal_component_get_dtend (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = util_ical_to_date_time (_tmp7_);
	_tmp9_ = _tmp8_;
	date_time_event_row_set_end_time (self, _tmp9_);
	_g_date_time_unref0 (_tmp9_);
	_g_object_unref0 (_tmp7_);
	_tmp11_ = self->priv->_end_time;
	if (_tmp11_ != NULL) {
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		_tmp12_ = self->priv->_start_time;
		_tmp13_ = self->priv->_end_time;
		_tmp10_ = util_is_the_all_day (_tmp12_, _tmp13_);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		date_time_event_row_set_is_allday (self, TRUE);
	}
	icon_name = "office-calendar-symbolic";
	_tmp14_ = self->priv->_end_time;
	if (_tmp14_ == NULL) {
		icon_name = "alarm-symbolic";
	}
	_tmp15_ = icon_name;
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp15_, (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->event_image);
	self->priv->event_image = _tmp16_;
	_tmp17_ = self->priv->event_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
	_tmp18_ = self->priv->event_image;
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
	event_image_context = _tmp19_;
	_tmp20_ = event_image_context;
	_tmp21_ = date_time_event_row_css_provider;
	gtk_style_context_add_provider (_tmp20_, (GtkStyleProvider*) _tmp21_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp22_ = self->priv->_component;
	_tmp23_ = i_cal_component_get_summary (_tmp22_);
	_tmp24_ = (GtkLabel*) gtk_label_new (_tmp23_);
	g_object_ref_sink (_tmp24_);
	name_label = _tmp24_;
	_tmp25_ = name_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
	_tmp26_ = name_label;
	gtk_label_set_ellipsize (_tmp26_, PANGO_ELLIPSIZE_END);
	_tmp27_ = name_label;
	gtk_label_set_lines (_tmp27_, 3);
	_tmp28_ = name_label;
	gtk_label_set_max_width_chars (_tmp28_, 30);
	_tmp29_ = name_label;
	g_object_set (_tmp29_, "wrap", TRUE, NULL);
	_tmp30_ = name_label;
	g_object_set (_tmp30_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	_tmp31_ = name_label;
	gtk_label_set_xalign (_tmp31_, (gfloat) 0);
	_tmp32_ = name_label;
	_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
	name_label_context = _tmp33_;
	_tmp34_ = name_label_context;
	gtk_style_context_add_class (_tmp34_, "title");
	_tmp35_ = name_label_context;
	_tmp36_ = date_time_event_row_css_provider;
	gtk_style_context_add_provider (_tmp35_, (GtkStyleProvider*) _tmp36_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp37_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp37_;
	_tmp38_ = self->priv->time_label;
	gtk_label_set_use_markup (_tmp38_, TRUE);
	_tmp39_ = self->priv->time_label;
	gtk_label_set_xalign (_tmp39_, (gfloat) 0);
	_tmp40_ = self->priv->time_label;
	_tmp41_ = gtk_widget_get_style_context ((GtkWidget*) _tmp40_);
	gtk_style_context_add_class (_tmp41_, GTK_STYLE_CLASS_DIM_LABEL);
	_tmp42_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp42_;
	_tmp43_ = self->priv->grid;
	gtk_grid_set_column_spacing (_tmp43_, 6);
	_tmp44_ = self->priv->grid;
	g_object_set ((GtkWidget*) _tmp44_, "margin", 3, NULL);
	_tmp45_ = self->priv->grid;
	_tmp46_ = self->priv->grid;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp46_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp45_, 6);
	_tmp47_ = self->priv->grid;
	_tmp48_ = self->priv->event_image;
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, 0, 0, 1, 1);
	_tmp49_ = self->priv->grid;
	_tmp50_ = name_label;
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 1, 0, 1, 1);
	_tmp51_ = self->priv->_is_allday;
	if (!_tmp51_) {
		GtkGrid* _tmp52_;
		GtkLabel* _tmp53_;
		_tmp52_ = self->priv->grid;
		_tmp53_ = self->priv->time_label;
		gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 1, 1, 1, 1);
	}
	_tmp54_ = self->priv->grid;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	grid_context = _tmp55_;
	_tmp56_ = grid_context;
	gtk_style_context_add_class (_tmp56_, "event");
	_tmp57_ = grid_context;
	_tmp58_ = date_time_event_row_css_provider;
	gtk_style_context_add_provider (_tmp57_, (GtkStyleProvider*) _tmp58_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp59_ = self->priv->grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp59_);
	date_time_event_row_set_color (self);
	_tmp60_ = self->priv->_cal;
	g_signal_connect_object ((GObject*) _tmp60_, "notify::color", (GCallback) _date_time_event_row_set_color_g_object_notify, self, 0);
	date_time_event_row_update_timelabel (self);
	_tmp61_ = date_time_event_row_time_manager;
	g_signal_connect_object ((GObject*) _tmp61_, "notify::is-12h", (GCallback) _date_time_event_row_update_timelabel_g_object_notify, self, 0);
	_g_object_unref0 (name_label);
	return obj;
}

static void
date_time_event_row_class_init (DateTimeEventRowClass * klass,
                                gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	DateTimeServicesTimeManager* _tmp2_;
	date_time_event_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DateTimeEventRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_event_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_event_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = date_time_event_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = date_time_event_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_EVENT_ROW_DATE_PROPERTY, date_time_event_row_properties[DATE_TIME_EVENT_ROW_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_EVENT_ROW_COMPONENT_PROPERTY, date_time_event_row_properties[DATE_TIME_EVENT_ROW_COMPONENT_PROPERTY] = g_param_spec_object ("component", "component", "component", i_cal_component_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_EVENT_ROW_CAL_PROPERTY, date_time_event_row_properties[DATE_TIME_EVENT_ROW_CAL_PROPERTY] = g_param_spec_object ("cal", "cal", "cal", e_source_calendar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_EVENT_ROW_START_TIME_PROPERTY, date_time_event_row_properties[DATE_TIME_EVENT_ROW_START_TIME_PROPERTY] = g_param_spec_boxed ("start-time", "start-time", "start-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_EVENT_ROW_END_TIME_PROPERTY, date_time_event_row_properties[DATE_TIME_EVENT_ROW_END_TIME_PROPERTY] = g_param_spec_boxed ("end-time", "end-time", "end-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_EVENT_ROW_IS_ALLDAY_PROPERTY, date_time_event_row_properties[DATE_TIME_EVENT_ROW_IS_ALLDAY_PROPERTY] = g_param_spec_boolean ("is-allday", "is-allday", "is-allday", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = gtk_css_provider_new ();
	_g_object_unref0 (date_time_event_row_css_provider);
	date_time_event_row_css_provider = _tmp0_;
	_tmp1_ = date_time_event_row_css_provider;
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/desktop/wingpanel/datetime/EventRow.css");
	_tmp2_ = date_time_services_time_manager_get_default ();
	_g_object_unref0 (date_time_event_row_time_manager);
	date_time_event_row_time_manager = _tmp2_;
}

static void
date_time_event_row_instance_init (DateTimeEventRow * self,
                                   gpointer klass)
{
	self->priv = date_time_event_row_get_instance_private (self);
	self->priv->_is_allday = FALSE;
}

static void
date_time_event_row_finalize (GObject * obj)
{
	DateTimeEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRow);
	_g_date_time_unref0 (self->priv->_date);
	_g_date_time_unref0 (self->priv->_start_time);
	_g_date_time_unref0 (self->priv->_end_time);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->event_image);
	_g_object_unref0 (self->priv->time_label);
	G_OBJECT_CLASS (date_time_event_row_parent_class)->finalize (obj);
}

static GType
date_time_event_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeEventRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_event_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeEventRow), 0, (GInstanceInitFunc) date_time_event_row_instance_init, NULL };
	GType date_time_event_row_type_id;
	date_time_event_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DateTimeEventRow", &g_define_type_info, 0);
	DateTimeEventRow_private_offset = g_type_add_instance_private (date_time_event_row_type_id, sizeof (DateTimeEventRowPrivate));
	return date_time_event_row_type_id;
}

GType
date_time_event_row_get_type (void)
{
	static volatile gsize date_time_event_row_type_id__volatile = 0;
	if (g_once_init_enter (&date_time_event_row_type_id__volatile)) {
		GType date_time_event_row_type_id;
		date_time_event_row_type_id = date_time_event_row_get_type_once ();
		g_once_init_leave (&date_time_event_row_type_id__volatile, date_time_event_row_type_id);
	}
	return date_time_event_row_type_id__volatile;
}

static void
_vala_date_time_event_row_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	DateTimeEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRow);
	switch (property_id) {
		case DATE_TIME_EVENT_ROW_DATE_PROPERTY:
		g_value_set_boxed (value, date_time_event_row_get_date (self));
		break;
		case DATE_TIME_EVENT_ROW_COMPONENT_PROPERTY:
		g_value_set_object (value, date_time_event_row_get_component (self));
		break;
		case DATE_TIME_EVENT_ROW_CAL_PROPERTY:
		g_value_set_object (value, date_time_event_row_get_cal (self));
		break;
		case DATE_TIME_EVENT_ROW_START_TIME_PROPERTY:
		g_value_set_boxed (value, date_time_event_row_get_start_time (self));
		break;
		case DATE_TIME_EVENT_ROW_END_TIME_PROPERTY:
		g_value_set_boxed (value, date_time_event_row_get_end_time (self));
		break;
		case DATE_TIME_EVENT_ROW_IS_ALLDAY_PROPERTY:
		g_value_set_boolean (value, date_time_event_row_get_is_allday (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_date_time_event_row_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	DateTimeEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_EVENT_ROW, DateTimeEventRow);
	switch (property_id) {
		case DATE_TIME_EVENT_ROW_DATE_PROPERTY:
		date_time_event_row_set_date (self, g_value_get_boxed (value));
		break;
		case DATE_TIME_EVENT_ROW_COMPONENT_PROPERTY:
		date_time_event_row_set_component (self, g_value_get_object (value));
		break;
		case DATE_TIME_EVENT_ROW_CAL_PROPERTY:
		date_time_event_row_set_cal (self, g_value_get_object (value));
		break;
		case DATE_TIME_EVENT_ROW_START_TIME_PROPERTY:
		date_time_event_row_set_start_time (self, g_value_get_boxed (value));
		break;
		case DATE_TIME_EVENT_ROW_END_TIME_PROPERTY:
		date_time_event_row_set_end_time (self, g_value_get_boxed (value));
		break;
		case DATE_TIME_EVENT_ROW_IS_ALLDAY_PROPERTY:
		date_time_event_row_set_is_allday (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

